// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_MODELCONSTRAINTMANAGER
#define _H_MODELCONSTRAINTMANAGER

#include "ModelInterface.h"
#include <set>

#include "MAdSingleton.h"

namespace MAd {

  // -------------------------------------------------------------------

  class ModelConstraintManager {

  public:
  
    ModelConstraintManager()  {};
    ~ModelConstraintManager() {};

    void initialize(pGModel);
    void finalize();
    void setModel(pGModel);

  public:

    void clear();

    void constrain  (int type, int id);
    void constrain  (pGEntity);

    void unconstrain(int type, int id);
    void unconstrain(pGEntity);

    bool constrained(pGEntity);

  private:

    pGModel model;
    std::set<pGEntity> constrEntities;
  };

  // -------------------------------------------------------------------

  typedef MAdSingleton<ModelConstraintManager> ModelConstraintManagerSgl;

}

#endif
