// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_CURVEDDESCOP
#define _H_CURVEDDESCOP

#include "MAdOperatorBase.h"
#include "DESCOp.h"

namespace MAd {

  // -------------------------------------------------------------------
//   class CurvedDESCOp: public MAdOperatorBase
  class CurvedDESCOp: public DESCOp
  {
  public:
  
    CurvedDESCOp(pMesh, DiscreteSF *);
    CurvedDESCOp(const CurvedDESCOp &);
    ~CurvedDESCOp() {}

    operationType type() const { return MAd_DESPLTCLPS; }

    void setDESC(pRegion, pEdge, pEdge);

    void getCavity(pPList *) const;

    void apply();

  private:

    bool checkConstraints() const;
    bool checkGeometry();
    bool evaluateShapes();
    void evaluateLengths() const;

  private:

    pRegion region;
    pEdge splitE[2];
    double xyz[3];
  };


  // -------------------------------------------------------------------
  inline CurvedDESCOp::CurvedDESCOp(const CurvedDESCOp &_desc):
  DESCOp(_desc)
//     MAdOperatorBase(_desc)
  {
    region = _desc.region;
    splitE[0] = _desc.splitE[0];
    splitE[1] = _desc.splitE[1];
  
    xyz[0] = _desc.xyz[0];
    xyz[1] = _desc.xyz[1];
    xyz[2] = _desc.xyz[2];
  }

  // -------------------------------------------------------------------
  inline CurvedDESCOp::CurvedDESCOp(pMesh _m, DiscreteSF * _sf):
  DESCOp(_m,_sf), region(NULL)
//     MAdOperatorBase(_m,_sf), region(NULL)
  {
    splitE[0] = NULL;
    splitE[1] = NULL;

    xyz[0] = 0.0;
    xyz[1] = 0.0;
    xyz[2] = 0.0;
  }

  // -------------------------------------------------------------------

}

#endif
