// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_CURVEDOPERATORTOOLS
#define _H_CURVEDOPERATORTOOLS

#include "MeshDataBaseInterface.h"
#include "pointprojector.h"

namespace MAd {
  
  namespace CurvedToolBox {
  // -------------------------------------------------------------------  
  
  double regularizeEdge(pEdge &edge);
    
  double edgeLength(pEdge edge, double uend = 1.0);
  
  bool isVertexOnBoundary( pVertex V);
  
  void cavity2D( pVertex v, pPList mylist, pGEntity entity = NULL, int bandwidth = 0);
  
  pEdge createHOEdge( pMesh mesh, pVertex v1, pVertex v2, int order, pGEntity eGEntity);
  
  pRegion createHOTetraFromVertices(pMesh mesh, pVertex verts[4], int o, pGEntity pGE);
  
  pRegion createHOTetraFromFaces(pMesh mesh, pFace f1, pFace f2, pFace f3, pFace f4, pGEntity pGE);

  pEdge createLinearHOEdge(pMesh mesh, pVertex v1, pVertex v2, int order, pGEntity eGEntity);

  pFace createHOFaceFromEdges(pMesh mesh, pEdge e1, pEdge e2, pEdge e3, pGEntity pGE);
  
  bool V_setPosition(pVertex, double[3]);
  
  void controlPointsTriangle(double uv1[2], double uv2[2], double uv3[2], int o, double *uf, double *vf);
  
  // --- Related to edge collapse ---

  void E_collapse(pMesh,   // the mesh
                  pEdge,   // the edge to be collapsed
                  pVertex, // the vertex to be deleted
                  pVertex  // the target vertex
                  );

  void E_collapseOnGFace(pMesh,   // the mesh
                         pEdge,   // the edge to be collapsed
                         pVertex, // the vertex to be deleted
                         pVertex  // the target vertex
                         );

  // --- Related to edge split ---

  pVertex E_split(pMesh, pEdge, double[3], double t=0.5); 
  }
}

#endif

