// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_DESCOP
#define _H_DESCOP

#include "MAdOperatorBase.h"

namespace MAd {

  // -------------------------------------------------------------------
  class DESCOp: public MAdOperatorBase
  {
  public:
  
    DESCOp(pMesh, DiscreteSF *);
    DESCOp(const DESCOp &);
    virtual ~DESCOp() {};

    operationType type() const { return MAd_DESPLTCLPS; }

    virtual void setDESC(pRegion, pEdge, pEdge) = 0;

    virtual void getCavity(pPList *) const = 0;

    virtual void apply() = 0;

  private:

    virtual bool checkConstraints() const = 0;
    virtual bool checkGeometry() = 0;
    virtual bool evaluateShapes() = 0;
    virtual void evaluateLengths() const = 0;

  };


  // -------------------------------------------------------------------
  inline DESCOp::DESCOp(const DESCOp &_desc):
    MAdOperatorBase(_desc)
  {
  }

  // -------------------------------------------------------------------
  inline DESCOp::DESCOp(pMesh _m, DiscreteSF * _sf):
    MAdOperatorBase(_m,_sf)
  {
  }

  // -------------------------------------------------------------------

}

#endif
