// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_EDGECOLLAPSEOP
#define _H_EDGECOLLAPSEOP

#include "MAdOperatorBase.h"
#include "MeshSizeBase.h"

namespace MAd {
  
  class edgeCollapseOp: public MAdOperatorBase
  {
  public:
    edgeCollapseOp() {};
    edgeCollapseOp(pMesh, DiscreteSF *);
    edgeCollapseOp(const edgeCollapseOp &);
    virtual ~edgeCollapseOp();
    
    operationType type() const { return MAd_ECOLLAPSE; }
    
    virtual void collapseOnBoundary(bool, double) = 0;
    virtual void setCollapseEdge(pEdge, pVertex, pVertex) = 0;
    
    void getCavity(pPList *) const = 0;
    
    void apply() = 0;
    
  private:
    
    virtual bool checkConstraints() const = 0;
    virtual bool checkGeometry() = 0;
    virtual bool evaluateShapes() = 0;
    virtual bool evaluateShapes2D() = 0;
    virtual void evaluateLengths() const = 0;
    
  };

  inline edgeCollapseOp::edgeCollapseOp(pMesh _mesh, DiscreteSF * _sf) : MAdOperatorBase(_mesh,_sf)
  {
    
  }
  
  inline edgeCollapseOp::edgeCollapseOp(const edgeCollapseOp & _es) : MAdOperatorBase(_es)
  {
    
  }
  inline edgeCollapseOp::~edgeCollapseOp()
  {
  }
}

#endif
