// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_EDGESWAPOP
#define _H_EDGESWAPOP

#include "MAdOperatorBase.h"
#include "EdgeSwapConfig.h"

namespace MAd {

  // -------------------------------------------------------------------
  class edgeSwapOp : public MAdOperatorBase
  {
  public:

    edgeSwapOp();
    edgeSwapOp(pMesh, DiscreteSF *);
    edgeSwapOp(const edgeSwapOp &);
    virtual ~edgeSwapOp() {}

    operationType type() const { return MAd_ESWAP; }
    int getMaxNumRgns() { return 7; }

    virtual void setSwapEdge(pEdge) = 0;
    virtual void swapOnBoundary(bool,double) = 0;

    void getCavity(pPList *) const = 0;

    virtual void apply() = 0;

  private:

    virtual bool checkConstraints() const = 0;
    virtual bool checkGeometry() = 0;
    virtual bool evaluateShapes() = 0;
    virtual void evaluateLengths() const = 0;

    // reporting
    void reportSwap( );

  };

  // -------------------------------------------------------------------
  inline edgeSwapOp::edgeSwapOp(pMesh _m, DiscreteSF * _sf):
    MAdOperatorBase(_m,_sf)
  {
    
  }

  // -------------------------------------------------------------------
  inline edgeSwapOp::edgeSwapOp(const edgeSwapOp & _es):
    MAdOperatorBase(_es)
  {
    
  }

}
// -------------------------------------------------------------------
#endif
