// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_EDGESPLITCOLLAPSEOP
#define _H_EDGESPLITCOLLAPSEOP

#include "MAdOperatorBase.h"

namespace MAd {

  // -------------------------------------------------------------------
  class faceCollapseOp: public MAdOperatorBase
  {
  public:
    faceCollapseOp() {};
    faceCollapseOp(pMesh, DiscreteSF *);
    faceCollapseOp(const faceCollapseOp &);
    virtual ~faceCollapseOp();

    operationType type() const { return MAd_FCOLLAPSE; }

    virtual void collapseOnBoundary(bool, double) = 0;
    virtual void reset(pFace, pEdge, bool) = 0;

    void getCavity(pPList *) const = 0;

    virtual void apply() = 0;

  private:

    virtual bool checkConstraints() const = 0;
    virtual bool checkGeometry() = 0;
    virtual bool evaluateShapes() = 0;
    virtual bool evaluateShapes2D() = 0;
    virtual void evaluateLengths() const = 0;

  };


  // -------------------------------------------------------------------
  inline faceCollapseOp::faceCollapseOp(const faceCollapseOp & _fc):
    MAdOperatorBase(_fc)
  {
  }

  // -------------------------------------------------------------------
  inline faceCollapseOp::faceCollapseOp(pMesh _m, DiscreteSF * _sf):
    MAdOperatorBase(_m,_sf)
  {
  }

  // -------------------------------------------------------------------
  inline faceCollapseOp::~faceCollapseOp()
  {
    
  }
  // -------------------------------------------------------------------

}

#endif
