// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_FACESWAPOP
#define _H_FACESWAPOP

#include "MAdOperatorBase.h"

namespace MAd {

  // -------------------------------------------------------------------
  class faceSwapOp: public MAdOperatorBase
  {
  public:
    faceSwapOp() {};
    faceSwapOp(pMesh, DiscreteSF *);
    faceSwapOp(const faceSwapOp &);
    virtual ~faceSwapOp();

    operationType type() const { return MAd_FSWAP; }
  
    virtual void setSwapFace(pFace) = 0;

    void getCavity(pPList *) const = 0;

    virtual void apply() = 0;

  private:

    virtual bool checkConstraints() const = 0;
    virtual bool checkGeometry() = 0;
    virtual bool evaluateShapes() = 0;
    virtual void evaluateLengths() const = 0;

  };

  // -------------------------------------------------------------------
  inline faceSwapOp::faceSwapOp(const faceSwapOp & _fs):
    MAdOperatorBase(_fs)
  {
    
  }

  // -------------------------------------------------------------------
  inline faceSwapOp::faceSwapOp(pMesh _m, DiscreteSF * _sf):
    MAdOperatorBase(_m,_sf)
  {
    
  }

  // -------------------------------------------------------------------
  inline faceSwapOp::~faceSwapOp()
  {
    
  }

  // -------------------------------------------------------------------

}

#endif
