// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_SLIVERFACEHANDLER
#define _H_SLIVERFACEHANDLER

#include "MAdOperatorBase.h"

#include <string>

namespace MAd {

  // -------------------------------------------------------------------
  class sliverFaceHandler {

  public:
    sliverFaceHandler() : mqm(MeshQualityManagerSgl::instance()) {};
    sliverFaceHandler(pMesh, DiscreteSF *);
    virtual ~sliverFaceHandler() {};

  public:

    virtual void removeSliverFaces(int * nbIn=NULL, int * nbOut=NULL) = 0;

    virtual void setSizeField(DiscreteSF *) = 0;

    // whether we can use operations on boundaries
    virtual void collapseOnBoundary(bool, double) = 0;

    // whether we can use operations that add nodes
    virtual void newVertexPermission(bool) = 0;
    virtual bool getNewVertexPermission() const =0;

    virtual void enableReport(std::string) = 0;

  private:

    MeshQualityManager& mqm;


  };

  // -------------------------------------------------------------------
  inline sliverFaceHandler::sliverFaceHandler(pMesh m, DiscreteSF * sf):
    mqm(MeshQualityManagerSgl::instance())
  {}
  /*
  // -------------------------------------------------------------------
  inline void sliverFaceHandler::setSizeField(DiscreteSF * sf)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverFaceHandler::collapseOnBoundary(bool cob, double tolerance)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverFaceHandler::newVertexPermission(bool allow)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverFaceHandler::enableReport(std::string prefix)
  {
  }
  */
  // -------------------------------------------------------------------

}

#endif

