// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_SLIVERREGIONHANDLER
#define _H_SLIVERREGIONHANDLER

#include "MAdOperatorBase.h"

#include <set>
#include <iostream>
#include <string>

#define MAKESTATS 1

namespace MAd {

  // -------------------------------------------------------------------
  class sliverRegionHandler {

  public:
    
    sliverRegionHandler(pMesh, DiscreteSF *);
    virtual ~sliverRegionHandler();

  public:

    virtual void removeSliverRegions(int * nbIn=NULL, int * nbOut=NULL) = 0;

    virtual void setSizeField(DiscreteSF *) = 0;

    // whether we can use operations on boundaries
    virtual void collapseOnBoundary(bool, double) = 0;
    virtual void swapOnBoundary(bool, double) = 0;

    // whether we can use operations that add nodes
    virtual void newVertexPermission(bool) = 0;
    virtual bool getNewVertexPermission() const = 0;

    virtual void enableReport(std::string) = 0;
    virtual void setTestAllOperators(bool) = 0;


  public:

    virtual void testOperations(pRegion) = 0;

    virtual void printStats(std::ostream&) const = 0;
    virtual void printOperatorsTest(std::ostream&) const = 0;

  };

  // -------------------------------------------------------------------
  inline sliverRegionHandler::sliverRegionHandler(pMesh m, DiscreteSF * sf)
  {
    
  }
  
  // -------------------------------------------------------------------
  inline sliverRegionHandler::~sliverRegionHandler()
  {
    
  }
  /*
  // -------------------------------------------------------------------
  inline void sliverRegionHandler::setSizeField(DiscreteSF * sf)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverRegionHandler::collapseOnBoundary(bool cob, double tolerance)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverRegionHandler::swapOnBoundary(bool sob, double tolerance)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverRegionHandler::newVertexPermission(bool allow)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverRegionHandler::enableReport(std::string prefix)
  {
  }

  // -------------------------------------------------------------------
  inline void sliverRegionHandler::setTestAllOperators(bool test)
  {
  }
  */
  // -------------------------------------------------------------------

}

#endif
