// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_MADOUTPUT
#define _H_MADOUTPUT

#include "MAdExport.h"
#include "ISizeField.h"
#include "MeshDataBaseInterface.h"

namespace MAd {

  // -------------------------------------------------------------------
  typedef enum MAdOutputData {
    OD_CONSTANT = 0,
    OD_MEANRATIO = 1,
    OD_GAMMA = 2,
    OD_ORIENTEDMEANRATIO = 3,
    OD_SIZEFIELD_MEAN = 4,
    OD_SIZEFIELD_MIN = 5,
    OD_SIZEFIELD_MAX = 6,
    OD_DIMENSION = 7,
    OD_ITERORDER = 8,
    OD_CURVATURE_DIV = 9,
    OD_CURVATURE_MAX = 10,
    OD_CURVATURE_MIN = 11,
    OD_CURVATURE_MAX_VEC = 12,
    OD_CURVATURE_MIN_VEC = 13,
    OD_ANISO_SF_AXIS0 = 14,
    OD_ANISO_SF_AXIS1 = 15,
    OD_ANISO_SF_AXIS2 = 16,
    OD_DISTANCE       = 17,
    OD_MAX_DIHEDRAL_ANGLE = 18
  } MAdOutputData;

  // -------------------------------------------------------------------

  typedef double(*MAdSpaceFunction) (const void * data, double xyz[3]);

  // -------------------------------------------------------------------

  MAD_EXPORT void MAdGmshOutput(const pMesh m, const ISizeField * sf, const char *fn, MAdOutputData type);
  MAD_EXPORT void MAdGmshOutput(const pMesh m, MAdSpaceFunction fct, const void * data, const char *fn);
  
  MAD_EXPORT void MAdAttachedNodalDataOutput   (const pMesh m, const char *fn, pMeshDataId id);
  MAD_EXPORT void MAdAttachedNodalDataVecOutput(const pMesh m, const char *fn, pMeshDataId id);

  // -------------------------------------------------------------------

}

#endif
