// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_GAMMAEVALUATOR
#define _H_GAMMAEVALUATOR

#include "ElementEvaluatorBase.h"

/* -------------------------------------------------------------------


------------------------------------------------------------------- */

namespace MAd {

  // -------------------------------------------------------------------
  class gammaEvaluator : public elementEvaluatorBase
  {
  public: 
    gammaEvaluator(const DiscreteSF * f);
    virtual ~gammaEvaluator() {}

    virtual int F_shape(const pFace pf, const double normal[3], double * result) const;
    virtual int F_shapeWithDisp(const pFace pf, const double normal[3],
                                double disp[3][3], double * result) const;
    virtual int R_shape(const pRegion pr, double * result) const;
    virtual int R_shapeWithDisp(const pRegion rgn, double disp[4][3], 
                                double * shape) const;
    virtual int XYZ_F_shape(const double[3][3], const pMSize[3], const double normal[3], double * result) const;
    virtual int XYZ_R_shape(const double[4][3], const pMSize[4], double * result) const;

    virtual evaluationType getType () const {return GAMMA;}
    virtual std::string getName () const {return "Gamma";}

  protected:
    virtual int XYZ_F_shape(const double[3][3], const pMSize pS, const double normal[3], double * result) const;
    virtual int XYZ_R_shape(const double[4][3], const pMSize pS, double * result) const;
  };

  // -------------------------------------------------------------------

}

#endif
