// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_NODESREPOSITIONINGOP
#define _H_NODESREPOSITIONINGOP

#include "DiscreteSF.h"
#include "MeshQualityManager.h"
#include "MeshDataBaseInterface.h"

namespace MAd {

  // -------------------------------------------------------------------
  enum repositionType {
    LAPLACE_FAST,
    LAPLACE_OPTIMAL
  };

  // -------------------------------------------------------------------
  class nodesRepositioningOp {

  public:

    nodesRepositioningOp(pMesh m, DiscreteSF * sf): 
      mesh(m), sizeField(sf), mqm(MeshQualityManagerSgl::instance())
    {
      dim = 3;
      if ( M_numRegions(mesh) == 0 ) dim = 2;
    }
    virtual ~nodesRepositioningOp() {}

  public:

    virtual int run(double * L2Norm)=0;

  protected:

    pMesh mesh;
    int dim;
    DiscreteSF * sizeField;
    MeshQualityManager& mqm;

  };

  // -------------------------------------------------------------------

}

#endif
