// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_CALLBACKMANAGER
#define _H_CALLBACKMANAGER

#include "MAdSingleton.h"
#include "IMeshAdapter.h"

#include <list>

namespace MAd {

    // -------------------------------------------------------------------
    struct CBStructure {

        CBFunction function;
        void* data;

        bool operator== (CBStructure cb) const {
            if (function == cb.function && data == cb.data) return true;
            return false;
        }
    };

    // -------------------------------------------------------------------
    struct CBStructureMove {
        CBFunc_move function;
        void* data;

        bool operator== (CBStructureMove cbm) const {
            if (function == cbm.function && data == cbm.data) return true;
            return false;
        }
    };

  // -------------------------------------------------------------------
  class CallBackManager {

  public:
  
    CallBackManager() {};
    ~CallBackManager() {};
  
    void initialize();
    void finalize();

    void registerCallBack(CBFunction CB, void* userData);
    void registerCallBackMove(CBFunc_move CB_move, void* userData_move);

    void unregisterCallBack(CBFunction CB, void* userData);
    void unregisterCallBackMove(CBFunc_move CB_move, void* userData_move);

    void callCallBacks(pPList before, pPList after,
                       operationType type , pEntity ppp);
    void callCallBackMoves(pVertex, double *);
  
  private:

    std::list<CBStructure> CB;
    std::list<CBStructureMove> CBMove;

  };

  // -------------------------------------------------------------------

  typedef MAdSingleton<CallBackManager> CallBackManagerSgl;

}

#endif
