set term postscript eps enhanced "Helvetica" 48
# color
set output "cpu.eps"
#set nokey
set key left top
set xlabel "Number of nodes (k)" font "Helvetica,54"
set ylabel "CPU time / time step (sec)" font "Helvetica,54"
set size 2., 2.

set style line 1 lt 3 lw 10
set style line 2 lt 1 lw 10

set style line 3 lt 7 lw 10
set style line 4 lt 2 lw 10
set style line 5 lt 8 lw 10
set style line 6 lt 9 lw 10

plot \
'perf_gnu.txt' u ($1)/1000:2 lw 10 ps 4 w lp t 'Adaptation procedure',\
'perf_gnu.txt' u ($1)/1000:3 lw 10 ps 4 w lp t 'Nodes repositioning',\
'perf_gnu.txt' u ($1)/1000:($2)+($3) lw 10 ps 4 w lp t 'Global procedure'

#plot '../long_0512/result/quality' u 1:2 ls 1 w l t '( 0.5 , 1.2 )',\
#'../long_0514/result/quality' u 1:2 ls 2 w l t '( 0.5 , 1.4 )',\
#'../long_0516/result/quality' u 1:2 ls 3 w l t '( 0.5 , 1.6 )',\
#'../long_0518/result/quality' u 1:2 ls 4 w l t '( 0.5 , 1.8 )'
#'../long_0310/result/quality' u 1:2 ls 1 w l t '( 0.3 , 1.0 )',\
#'../long_1024/result/quality' u 1:2 ls 6 w l t '( 1.0 , 2.4 )'


set out
set term x11
replot
