// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _H_MYPARAMS
#define _H_MYPARAMS

#include "Parameters.h"

// ----------------------------------------------------------------------
void setCurrentParameters(MoveParameters * params) {

  params->meshFileName = "square.msh";
  params->geoFileName  = "square.geo";
  
  // global output parameters
  // ------------------------

  params->outFrequency = 1;
  params->outType = "Msh"; // "Msh", "Pos" or "MshAndPos"
  params->outPrefix = "result/";

  // Global task parameters
  // ----------------------

//   params->task = "MobileObject";

  // debugging parmeters
  // --------------------

  params->debugLevel = 0;
//   params->openJournal = false;
//   params->referenceJournal = "";
//   params->sliverReports = false;
//   params->testSliverOperators = false;

  // Mesh adaptation
  // ----------------

//   params->maxInnerIter = 10;
//   params->lowerLength = 0.577;
//   params->upperLength = 1.732;
//   params->swapMinImproveRatio = 1.0;
//   params->sliverQuality = 0.02;
//   params->splitCanMakeSlivers = true;
//   params->makeSliverInSplitLenSqBound = 0.1;
//   params->collapseCanMakeSlivers = true;
//   params->makeSliverInCollapseLenSqBound = 10.;
  params->collapseOnBoundary = true;
  params->clpOnBdryTolerance = 1.e-6;
  params->swapOnBoundary = true;
  params->swapOnBdryTolerance = 1.e-6;
  params->trackGeometry = false;
//   params->snap_cavityIsMesh = false;
//   params->snap_thickness = 3;
//   params->snap_chi = 1.;
  
//   params->SFSmoothing = false;
//   params->SFSmoothGrad = 1.;

  // Node motion
  // -----------

  params->nodeMotionType = "None";
//   params->elasticStiffnessAlteration = 1.0;
//   params->elasticIsMeshTheCavity = true;
//   params->elasticCavityThickness = 0;

  // Time parameters
  // ---------------

  params->timeStep = 0.01;
  params->finalTime = 3.0;
//   params->maxNbTimeSteps = 1;

  
  // Moving objects
  // --------------

  // Size Field parameters
  // ---------------------

  SizeFieldDef analSF;
  analSF.type = MAd::ANALYTICALSFIELD;
  analSF.orientation = ORT_ISOTROPIC;
  analSF.isoSize = "0.1+0.6*Cos(2.*3.14*t)";
//   analSF.orientation = ORT_ANISOTROPIC;
//   vector<string> myAnisoSize;
//   myAnisoSize.push_back("0.1");
//   myAnisoSize.push_back("1.");
//   myAnisoSize.push_back("1.");
//   analSF.anisoSize = myAnisoSize;
//   vector<string> anisoDir0;
//   anisoDir0.push_back("1.");
//   anisoDir0.push_back("0.");
//   anisoDir0.push_back("0.");
//   analSF.anisoDir0 = anisoDir0;
//   vector<string> anisoDir1;
//   anisoDir1.push_back("0.");
//   anisoDir1.push_back("1.");
//   anisoDir1.push_back("0.");
//   analSF.anisoDir1 = anisoDir1;
//   vector<string> anisoDir2;
//   anisoDir2.push_back("0.");
//   anisoDir2.push_back("0.");
//   anisoDir2.push_back("1.");
//   analSF.anisoDir2 = anisoDir2;

  params->sizes.push_back(analSF);
}

// ----------------------------------------------------------------------

#endif
