// -*- C++ -*-

// tube parameters
R = 1.;
dR = 0.2;
L2 = 8.;
lc2 = 0.1;

// external box parameters
B1 = 2.;
B3 = 2.;
C = 8.;
H = 12.;
lcBox = 1.;

// tube
Point(20) = {R,0,0,lc2};
Point(21) = {-R,0,0,lc2};
Point(22) = {0,R,0,lc2};
Point(23) = {0,-R,0,lc2};
Point(24) = {0,-R-dR,0,lc2};
Point(25) = {0,+R+dR,0,lc2};
Point(26) = {R+dR,0,0,lc2};
Point(27) = {-R-dR,0,0,lc2};
Point(28) = {0,0,0,lc2};
Circle(29) = {23,28,20};
Circle(30) = {20,28,22};
Circle(31) = {22,28,21};
Circle(32) = {21,28,23};
Circle(33) = {24,28,26};
Circle(34) = {26,28,25};
Circle(35) = {25,28,27};
Circle(36) = {27,28,24};
Extrude {0,0,L2} {
  Line{36,33,34,35,31,30,29,32};
}

// external box
Point(62) = {B3,C,-B1,lcBox};
Point(63) = {-B3,C,-B1,lcBox};
Point(64) = {-B3,-C,-B1,lcBox};
Point(65) = {B3,-C,-B1,lcBox};
Line(82) = {64,63};
Line(83) = {63,62};
Line(84) = {62,65};
Line(85) = {65,64};
Extrude {0,0,H} {
  Line{82,83,84,85};
}

// close tube
Line Loop(102) = {34, 35, 36, 33};
Line Loop(103) = {29, 30, 31, 32};
Plane Surface(104) = {102, 103};
Line Loop(105) = {45, 49, 37, 41};
Line Loop(106) = {57, 53, 65, 61};
Plane Surface(107) = {105, 106};

// close box
Line Loop(108) = {94, 98, 86, 90};
Plane Surface(109) = {108};
Line Loop(110) = {84, 85, 82, 83};
Plane Surface(111) = {110};

Surface Loop(112) = {111, 97, 101, 89, 93, 109};
Surface Loop(113) = {44, 104, 48, 52, 40, 107, 64, 60, 56, 68};
Volume(114) = {112, 113};
