// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

namespace MAd {
  template <class SCALAR> 
  MAd_Matrix<SCALAR>::MAd_Matrix(int R,int C) {
    allocate(R,C);
    set_all(0);
  }

  template <class SCALAR> 
  MAd_Matrix<SCALAR>::MAd_Matrix(const MAd_Matrix& other) {
    allocate(other._r,other._c);memcpy(other);
  }
    
  template <class SCALAR> 
  MAd_Matrix<SCALAR>::MAd_Matrix(): 
    _r(0),_c(0),_ld(0),
    _data(NULL),_cData(NULL),_cEnd(NULL),_owner(false) {}
    
  template <class SCALAR> 
  MAd_Matrix<SCALAR>::MAd_Matrix(SCALAR* d,int R,int C) : 
    _r(R),_c(C),_ld(R),_data(d),_cData(d),_owner(false) {}
  
  template <class SCALAR> 
  MAd_Matrix<SCALAR>::~MAd_Matrix() { 
    if (_data && _owner) delete [] _data; 
  }
  
  template <class SCALAR>
  void MAd_Matrix<SCALAR>::resize(int R,int C) {
    if (_data && _owner) delete [] _data;
    allocate(R,C);
    set_all(0);
  }
  
  
  template <class SCALAR>
  void MAd_Matrix<SCALAR>::allocate(int R,int C) {
    
    _data = new SCALAR[std::max(R*C,1)];
    _cData = _data;
    _cEnd = _cData + R*C;
    _r = R;
    _c = C;
    _owner = true;
    _ld = R;
  }
}
