// -*- C++ -*- 
// -----------------------------------------------------------------------------
// MAdLiB - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------


#ifndef MADINTERPOLANTFACTORY_HPP
#define MADINTERPOLANTFACTORY_HPP

#include "MAdSingleton.h"
#include "MAd_Interpolant.h"
#include "MshTags.h"

using namespace MAd; 

// -----------------------------------------------------------------------------
/*! \brief Static storage of interpolants */
// -----------------------------------------------------------------------------


class MAd_InterpolantFactory {
    
  friend class MAdSingleton<MAd_InterpolantFactory>;

public:
  
  const MAd_Interpolant* find(int type,int order) const;
  static int getMaxOrder() {return maxOrder;}
  
protected:

  MAd_InterpolantFactory();
  ~MAd_InterpolantFactory();

public:

  bool initialize();

private:
  
  static const int maxOrder;

  bool initialized;
  void add(int order);

  typedef std::map<std::pair<int,int>,MAd_Interpolant*> InterpolantMap;
  
  InterpolantMap interpolant;
  
};

// ---------------------------------------------------------------------------

typedef MAdSingleton<MAd_InterpolantFactory> MAd_InterpolantFactorySgl;

// ---------------------------------------------------------------------------

#endif
