// -*- C++ -*- 
// -----------------------------------------------------------------------------
// MAdLiB - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef MAD_INTERPOLANTMANAGER__H
#define MAD_INTERPOLANTMANAGER__H

#include "MAdSingleton.h"
#include "MAd_Interpolant.h"
#include <map>

namespace MAd {

  class MAd_InterpolantManager {

  public:
    
    /*! \brief find previously allocated function space */
    const  MAd_Interpolant* findFunctionSpace     (int);
    
    /*! \brief create functionspace of type fsT, for elementType elT and order */
    MAd_Interpolant* createFunctionSpace     (int) const;

  protected:

    MAd_InterpolantManager() {};
    ~MAd_InterpolantManager();
    
    typedef MAdSingleton<MAd_InterpolantManager> MAd_InterpolantManagerSgl;
    
    std::map<int,MAd_Interpolant*> interpolants;
    
  };
};

#endif
