// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _MeshDataBaseCOMM_H
#define _MeshDataBaseCOMM_H

#include "MeshDataBaseInterface.h"
#include "MeshDataBaseParallelInterface.h"

#include <map>

/*
  MDB_DataExchanger is a class that allow user to exchange
  data's between partitions and/or periodic boundaries. User
  has to provide a tag for non synchronous communications. 
  Basically, choose a tag that is higher that 200 for being
  sure that it does not interact with internal messages.
  User has to allocate buffers using malloc.

  User will receive its datas.
*/

namespace MAd {
  
  /*! \brief structure to store a periodic/parallel connection \ingroup parallel */ 

  struct EntityConnection {
    
    EntityConnection():remoteEntity(NULL),transform(NULL) {}
    EntityConnection(pEntity e,pTransform t):remoteEntity(e),transform(t) {};
    
    pEntity    remoteEntity; //!< pointer to remote entity (valid on other partition) 
    pTransform transform;    //!< transformation from this entity to the remote
  };

  /*! \brief stores all connections for an entity : processor to connection */
  
  typedef std::multimap<int,EntityConnection> ConnectionMap;
  

}

#endif
