// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef MESHDATABASEPARALLELCHECK_H
#define MESHDATABASEPARALLELCHECK_H

#include "MeshDataBaseComm.h"

#include <iostream>
#include <map>
#include <set>


namespace MAd {

  /*! \brief Class for checking orientation of corresponding entities \ingroup parallel */

  class MDB_CommCheck : public MDB_DataExchanger {

  public:

#ifdef PARALLEL
    MDB_CommCheck(MPI_Comm = MPI_COMM_WORLD);
#else
    MDB_CommCheck();
#endif

    void printStatus(std::ostream&) const;
    using MDB_DataExchanger::sendData; 
    virtual void* sendData(pEntity,int,int&);
    virtual void  receiveData(pEntity,int,void*);

  private:

    int numRecvs;
    int numSends;
    int numErrors;

    std::map<pEntity,std::set<std::pair<int,pEntity> > > communications;
    
#ifdef PARALLEL
    MPI_Comm mpi_communicator;
#endif
  
  };

}

#endif
