// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

#ifndef _PARALLELUTILS_H_
#define _PARALLELUTILS_H_

#if defined (_HAVE_METIS_) || defined (PARALLEL)
#include "MeshDataBaseInterface.h"
#endif

namespace MAd {

#ifdef _HAVE_METIS_
  void PartitionMesh(pMesh m, int nbPart, const char *);
#endif

#ifdef PARALLEL
  void E_facesAttachId(pMesh mesh,pMeshDataId tagAdj);
  void F_regionsAttachId(pMesh mesh,pMeshDataId tagAdj);

  // Functions added in MAdLib to avoid direct autopack dependence in final software
  void autopack_init(int *argc, char ***argv,MPI_Comm comm=MPI_COMM_WORLD);
  void autopack_setparam(int size, int packed, int nwait_proc, int nwait);
#endif

}

#endif
