// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------


#ifndef _HAVE_GMSH_

#include "NullModel.h"
#include "NullEntities.h"

namespace MAd {
  
  // -----------------------------------------------------------------
  void NullGEntity::setPhysical(int d, int t) {
    phys = model->getPhysical(d,t);
  }

  // -----------------------------------------------------------------
  
  bool NullGEntity::addInClosure(NullGEntity* ge) {
    if (ge->dim() != dim()+1) return false;
    inClosure.insert(ge);
    return true;
  }

  // -----------------------------------------------------------------

  bool NullGEdge::addClosure(NullGEntity* c) {
    NullGVertex* cv = dynamic_cast<NullGVertex*>(c);
    if (!cv) return false;
    closure.insert(cv);
    cv->addInClosure(this);
    return true;
  }

  // -----------------------------------------------------------------

  bool NullGFace::addClosure(NullGEntity* c) {
    NullGEdge* ce = dynamic_cast<NullGEdge*>(c);
    if (!ce) return false;
    closure.insert(ce);
    ce->addInClosure(this);
    return true;
  }

  // -----------------------------------------------------------------

  bool NullGRegion::addClosure(NullGEntity* c) {
    NullGFace* cf = dynamic_cast<NullGFace*>(c);
    if (!cf) return false;
    closure.insert(cf);
    cf->addInClosure(this);
    return true;
  }

  // -----------------------------------------------------------------
}
#endif
