// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------

/*
  Store a list of pointers to geometric entities

  The list is stored as a standart vector:
    - allow fast random access
    - allow fast iterating
    - can be allocated to a particular size
    - slow at randomly adding/removing elements but not useful here
*/

#ifndef _H_PGLIST
#define _H_PGLIST

#include "ModelInterface.h"

#include <vector>

namespace MAd {

  // -------------------------------------------------------------------
  class PGList {

  public:

    PGList() {};
    PGList(const PGList& ori)
    {
      entities = ori.entities;
    };
  
    ~PGList() {};

  public:

    void clear() { entities.clear(); };

  public:

    std::vector<MAdGEntity *> entities;

  };

  // -------------------------------------------------------------------

}

#endif
