#ifndef _DEFORM_H
#define _DEFORM_H

#include "MAdLib/MAdLib.h"
#include "MAdLib/MappingInterface.h"

#include "quadrature.h"
#include "fem.h"
#include "entityIds.h"
#include "tools.h"

#include "Eigen/Dense"
#include "Eigen/Sparse"

typedef Eigen::SparseMatrix<double,Eigen::RowMajor> SparseMatrix;

inline double f(double x){
  return .05+.25*(-x*x+1);
}

struct IdxCompare
{
    const std::vector<int>& target;
    IdxCompare(const std::vector<int>& target): target(target) {}
    bool operator()(int a, int b) const { return target[a] < target[b]; }
};


int getRHS(const MAd::pMesh mesh, const std::vector<int> &tags, std::vector<int> &isBc, Eigen::VectorXd &rhs);
int getMat(const MAd::pMesh mesh, int order, const std::vector<int> &isBc, SparseMatrix &mat, Eigen::VectorXd &rhs);
void getPeriodicityMat(const MAd::pMesh mesh, std::map<MAd::pTransform, std::vector<std::pair<int,int> > > &pairs, SparseMatrix &P1);
void deformMesh(MAd::pMesh mesh, Eigen::VectorXd &sol);

#endif
