#ifndef _TOOLS_H
#define _TOOLS_H

#include <vector>
#include <algorithm>
#include <iostream>

#include <math.h>

#include "MAdLib/MAdLib.h"

template<typename T>
inline bool isIn(std::vector<T> v, T val){
  return (std::find(v.begin(),v.end(),val) != v.end());
}

bool isPeriodic(const MAd::pMesh mesh);

MAd::pVertex getPeriodicVertex(const MAd::pMesh mesh, const MAd::pTransform transfo, const MAd::pVertex v);

double periodicityError(const MAd::pMesh mesh);

bool getBoundaries(MAd::pMesh mesh,std::map<int,std::vector<MAd::pEntity> > &bMap);

bool getMeshOrders(MAd::pMesh mesh, int dim, std::vector<int> &orders);

/* void print3(double x[3]){ */

/*   std::cout << "("<< x[0] << " " << x[1] << " " << x[2] << ")" << std::endl; */

/* } */
#endif
