// -------------------------------------------------------------------
// MAdLib - Copyright (C) Cenaero
//
// See the Copyright.txt and License.txt files for license information. 
// -------------------------------------------------------------------
#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "MeshDataBaseInterface.h"
#include "ModelInterface.h"
#ifdef _HAVE_MKL_
#include "mkl_service.h"
#endif

using namespace MAd;

int main(int argc, char* argv[])
{
#ifdef _HAVE_MKL_
  atexit(mkl_free_buffers);
#endif    
  pGModel null_model = 0; 
  GM_create(&null_model);
  pMesh p_mesh = M_new(null_model);

  std::string mshName( argv[1] );
  mshName += "/cube_4.msh";
  
  M_load(p_mesh, mshName.c_str());
  int nbrVertices = M_numVertices(p_mesh);
  
  M_delete( p_mesh );
  GM_delete( null_model );
  
  std::string refName( argv[1] );
  refName += "/qa_values_check.txt";
  std::ifstream ref_file( refName.c_str() );
  
  int nbr_values, ref_nbrVertices;
  ref_file >> nbr_values >> ref_nbrVertices;

  if(nbrVertices == ref_nbrVertices) 
    return 0;
  else
    return 1;  
}
