# This script must be included in the main CTest script
#

#ctest_start(${TESTMODEL})
set(CDASH_TRACK "Release")
ctest_start(${TESTMODEL} TRACK "${CDASH_TRACK}")

ctest_update(SOURCE "${CTEST_SOURCE_DIRECTORY}")
ctest_submit(PARTS Update)

ctest_configure(BUILD "${CTEST_BINARY_DIRECTORY}")
ctest_submit(PARTS Configure Notes)

ctest_build(BUILD "${CTEST_BINARY_DIRECTORY}" APPEND)
ctest_submit(PARTS Build)

if(DO_TEST OR NOT DEFINED DO_TEST)
  if(${REMOTE_SUBMISSION} STREQUAL "TRUE")
    set(PLATFORM $ENV{PLATFORM})
    if(${DO_MEMCHECK} STREQUAL "TRUE")
      configure_file(
        "${CTEST_SOURCE_DIRECTORY}/cmake/DashboardScripts/submit_ctest_memcheck.cmake.in"
        "${CTEST_BINARY_DIRECTORY}/cmake/DashboardScripts/submit_ctest_memcheck.cmake"
      )
      execute_process(COMMAND "qsub" "-W" "block=true" "${CTEST_BINARY_DIRECTORY}/cmake/DashboardScripts/submit_ctest_memcheck.job.pbs")
    else()
      configure_file(
        "${CTEST_SOURCE_DIRECTORY}/cmake/DashboardScripts/submit_ctest_test.cmake.in"
        "${CTEST_BINARY_DIRECTORY}/cmake/DashboardScripts/submit_ctest_test.cmake"
      )
      execute_process(COMMAND "qsub" "-W" "block=true" "${CTEST_BINARY_DIRECTORY}/cmake/DashboardScripts/submit_ctest_test.job.pbs")
    endif()
  else()
    if(${DO_MEMCHECK} STREQUAL "TRUE")
      ctest_memcheck(BUILD "${CTEST_BINARY_DIRECTORY}")
      ctest_submit(PARTS MemCheck)
    else()
      ctest_test(BUILD "${CTEST_BINARY_DIRECTORY}")
      ctest_submit(PARTS Test)
    endif()
  endif()
endif()

if(WIN32)
  execute_process(COMMAND "nmake" "install" "-i" WORKING_DIRECTORY ${CTEST_BINARY_DIRECTORY} )
else()
  execute_process(COMMAND "make" "install" "-i" WORKING_DIRECTORY ${CTEST_BINARY_DIRECTORY} )
endif()


