# This script must be included in the main CTest script
#
# It is the common part for the initialization step on sealion filesrv

cmake_minimum_required(VERSION 2.8)

# Name of the source and binary directory on disk. 
set(CTEST_SOURCE_DIRECTORY "/projects/cenaero/MADLIB/AutoCheck/Release_2_0/")
set(CTEST_BINARY_DIRECTORY "/SCRATCH/cenaero/MADLIB/AutoCheck/Release_2_0/build/${FILESRV}_${CONFIG_NAME}")

# Various program paths
set(CTEST_CMAKE_COMMAND "cmake") 
set(CTEST_COMMAND "ctest")
set(CTEST_UPDATE_COMMAND "svn")
set(CTEST_MEMORYCHECK_COMMAND "/usr/bin/valgrind")

# CTest configuration
set(CTEST_MEMORYCHECK_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --show-reachable=yes -v")
set(CTEST_MEMORYCHECK_SUPPRESSIONS_FILE "${CTEST_SOURCE_DIRECTORY}/cmake/DashboardScripts/mkl_serv_load_dll.supp")
list(APPEND CTEST_NOTES_FILES "${CTEST_SOURCE_DIRECTORY}/cmake/DashboardScripts/${FILESRV}_${CONFIG_NAME}.cmake")
list(APPEND CTEST_NOTES_FILES "${CTEST_SOURCE_DIRECTORY}/cmake/DashboardScripts/zenobe_nightly_config.cmake")
set(CTEST_CMAKE_GENERATOR "Unix Makefiles")
set(CTEST_SITE "${FILESRV}.cenaero")
set(CTEST_BUILD_NAME "Linux-${CONFIG_NAME}")

set(TESTMODEL "Nightly")
set(REMOTE_SUBMISSION "TRUE")

set(MADLIB_INSTALL_PREFIX "/softs/madlib/2.0.0")

