# -- Find ANN --
# Cenaero - 29/10/2009
#
# Inspired from: 
#   - http://cvs.savannah.gnu.org/viewvc/tsp/src/doxy/?root=tsp
#
# Find the doxygen executable
#
# Once done, this will define:
# - DOXYGEN_EXECUTABLE - Full path with executable name
# - DOXYGEN_FOUND - True if doxygen executable found

IF(DOXYGEN_EXECUTABLE)
  SET(DOXYGEN_FIND_QUIETLY ON)
ENDIF(DOXYGEN_EXECUTABLE)

IF (NOT DOXYGEN_FIND_QUIETLY)
  MESSAGE(STATUS "Looking for doxygen...")
ENDIF (NOT DOXYGEN_FIND_QUIETLY)

FIND_PROGRAM(DOXYGEN_EXECUTABLE
  NAMES doxygen
  PATHS "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\doxygen_is1;Inno Setup: App Path]/bin"
  /Applications/Doxygen.app/Contents/Resources
  /Applications/Doxygen.app/Contents/MacOS
  /usr/bin
  /usr/local/bin
  ${DOXYGEN_ROOT}
  DOC "Doxygen documentation generation tool (http://www.doxygen.org)"
)

IF (DOXYGEN_EXECUTABLE)
  SET (DOXYGEN_FOUND "YES")
  IF (NOT DOXYGEN_FIND_QUIETLY)
    MESSAGE(STATUS "Looking for doxygen... - found ${DOXYGEN_EXECUTABLE}")
  ENDIF (NOT DOXYGEN_FIND_QUIETLY)
ELSE (DOXYGEN_EXECUTABLE)
  IF (NOT DOXYGEN_FIND_QUIETLY)
    IF (DOXYGEN_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Looking for doxygen... - NOT found")
    ELSE (DOXYGEN_FIND_REQUIRED)
      MESSAGE(STATUS "Looking for doxygen... - NOT found")
    ENDIF (DOXYGEN_FIND_REQUIRED)
  ENDIF (NOT DOXYGEN_FIND_QUIETLY)
ENDIF (DOXYGEN_EXECUTABLE)

IF(DOXYGEN_FOUND)
  MARK_AS_ADVANCED(
    DOXYGEN_EXECUTABLE
  )
ENDIF()

