# -- Find METIS --
# Cenaero - 29/10/2009
#
# Find the native METIS headers and libraries.
#
# Input parameters which could influence the search:
# - METIS_ROOT - root folder where METIS is installed
#
# Once done, this will define:
# - METIS_INCLUDE_DIRS - where to find METIS headers - empty
# - METIS_LIBRARIES - List of libraries when using METIS.
# - METIS_FOUND - True if METIS found.
#

if(METIS_INCLUDE_DIR AND PARMETIS_INCLUDE_DIR AND AUTOPACK_INCLUDE_DIR AND METIS_LIBRARY AND PARMETIS_LIBRARY AND AUTOPACK_LIBRARY)
  set(METIS_FIND_QUIETLY TRUE)
endif()

include(LibFindMacros)

# Check input parameters
if(METIS_ROOT)
  set( _METIS_INCLUDE_SEARCH_DIRS 
       ${METIS_ROOT} ${METIS_ROOT}/METISLib
       ${AUTOPACK_ROOT} ${_METIS_INCLUDE_SEARCH_DIRS})
  set( _METIS_LIBRARY_SEARCH_DIRS ${METIS_ROOT}/lib ${METIS_ROOT} ${METIS_ROOT}/METISLib
       ${AUTOPACK_ROOT}${_METIS_LIBRARY_SEARCH_DIRS})
endif(METIS_ROOT)
# Dependencies
# ! none !

# Use pkg-config to get hints about paths
# libfind_pkg_check_modules(METIS_PKGCONF METIS)

# Look for the library
find_path(METIS_INCLUDE_DIR NAMES metis.h
          PATHS ${_METIS_INCLUDE_SEARCH_DIRS})
find_library(METIS_LIBRARY NAMES metis
             PATHS ${_METIS_LIBRARY_SEARCH_DIRS})

# Set the include dir variables and the libraries and let libfind_process do the rest
set(METIS_PROCESS_INCLUDES METIS_INCLUDE_DIR )
set(METIS_PROCESS_LIBS METIS_LIBRARY )
libfind_process(METIS)
