# -- Find METIS --
# Cenaero - 29/10/2009
#
# Find the native METIS headers and libraries.
#
# Input parameters which could influence the search:
# - METIS_ROOT - root folder where METIS is installed
#
# Once done, this will define:
# - METIS_INCLUDE_DIRS - where to find METIS headers - empty
# - METIS_LIBRARIES - List of libraries when using METIS.
# - METIS_FOUND - True if METIS found.
#

if(PARMETIS_LIBRARY)
  set(PARMETIS_FIND_QUIETLY TRUE)
endif(PARMETIS_LIBRARY)

include(LibFindMacros)

# Check input parameters
if(PARMETIS_ROOT)
  set( _PARMETIS_INCLUDE_SEARCH_DIRS
       ${PARMETIS_ROOT}
       ${PARMETIS_ROOT}/include ${PARMETIS_ROOT}/src ${PARMETIS_ROOT}/build/linux 
       ${PARMETIS_ROOT} ${_PARMETIS_INCLUDE_SEARCH_DIRS})
  set( _PARMETIS_LIBRARY_SEARCH_DIRS
       ${PARMETIS_ROOT}/lib ${PARMETIS_ROOT} ${_PARMETIS_LIBRARY_SEARCH_DIRS})
endif(PARMETIS_ROOT)

# Dependencies
# ! none !

# Use pkg-config to get hints about paths
# libfind_pkg_check_modules(METIS_PKGCONF METIS)

# Look for the library
find_path(PARMETIS_INCLUDE_DIR NAMES parmetis.h 
          PATHS ${_PARMETIS_INCLUDE_SEARCH_DIRS})
find_library(PARMETIS_LIBRARY NAMES parmetis 
             PATHS ${_PARMETIS_LIBRARY_SEARCH_DIRS} ${PARMETIS_PKGCONF_LIBRARY_DIRS})

# Set the include dir variables and the libraries and let libfind_process do the rest
set(PARMETIS_PROCESS_INCLUDES PARMETIS_INCLUDE_DIR)
set(PARMETIS_PROCESS_LIBS PARMETIS_LIBRARY)
libfind_process(PARMETIS)

