# -- Find PARSER --
# Cenaero - 10/06/2010
#
# Find the native PARSER headers and libraries.
#
# Input parameters which could influence the search:
# - PARSER_ROOT - root folder where PARSER is installed
#
# Once done, this will define:
# - PARSER_INCLUDE_DIRS - where to find PARSER headers - empty
# - PARSER_LIBRARIES - List of libraries when using PARSER.
# - PARSER_FOUND - True if PARSER found.
#

if(PARSER_LIBRARY)
  set(PARSER_FIND_QUIETLY TRUE)
endif(PARSER_LIBRARY)

include(LibFindMacros)

# Check input parameters
if(PARSER_ROOT)
  set( _PARSER_INCLUDE_SEARCH_DIRS
       ${PARSER_ROOT}/include ${PARSER_ROOT} ${_PARSER_INCLUDE_SEARCH_DIRS})
  set( _PARSER_LIBRARY_SEARCH_DIRS
       ${PARSER_ROOT}/lib ${PARSER_ROOT} ${_PARSER_LIBRARY_SEARCH_DIRS})
endif(PARSER_ROOT)

# Dependencies
# ! none !

# Use pkg-config to get hints about paths
# libfind_pkg_check_modules(PARSER_PKGCONF PARSER)

# Look for the library
find_path(PARSER_INCLUDE_DIR NAMES Parser.h 
          PATHS ${_PARSER_INCLUDE_SEARCH_DIRS})
find_library(PARSER_LIBRARY NAMES Parser 
             PATHS ${_PARSER_LIBRARY_SEARCH_DIRS} ${PARSER_PKGCONF_LIBRARY_DIRS})

# Set the include dir variables and the libraries and let libfind_process do the rest
set(PARSER_PROCESS_INCLUDES PARSER_INCLUDE_DIR)
set(PARSER_PROCESS_LIBS PARSER_LIBRARY)
libfind_process(PARSER)

