# -- Find PETSC --
# Cenaero - 10/06/2010
#
# Find the native PETSC headers and libraries.
#
# Input parameters which could influence the search:
# - PETSC_ROOT - root folder where PETSC is installed
#
# Once done, this will define:
# - PETSC_INCLUDE_DIRS - where to find PETSC headers - empty
# - PETSC_LIBRARIES - List of libraries when using PETSC.
# - PETSC_FOUND - True if PETSC found.
#

if(PETSC_LIBRARY)
  set(PETSC_FIND_QUIETLY TRUE)
endif(PETSC_LIBRARY)

include(LibFindMacros)

# Check input parameters
if(PETSC_ROOT)
  set( _PETSC_INCLUDE_SEARCH_DIRS
       ${PETSC_ROOT}/include ${PETSC_ROOT} ${_PETSC_INCLUDE_SEARCH_DIRS})
  set( _PETSC_LIBRARY_SEARCH_DIRS
       ${PETSC_ROOT}/lib ${PETSC_ROOT} ${_PETSC_LIBRARY_SEARCH_DIRS})
endif(PETSC_ROOT)

# Dependencies
# ! none !

# Use pkg-config to get hints about paths
# libfind_pkg_check_modules(PETSC_PKGCONF PETSC)

# Look for the library
find_path(PETSC_INCLUDE_DIR NAMES petsc.h 
          PATHS ${_PETSC_INCLUDE_SEARCH_DIRS})
# find_library(PETSC_LIBRARY NAMES Parser 
#              PATHS ${_PETSC_LIBRARY_SEARCH_DIRS} ${PETSC_PKGCONF_LIBRARY_DIRS})

# Set the include dir variables and the libraries and let libfind_process do the rest
set(PETSC_PROCESS_INCLUDES PETSC_INCLUDE_DIR)
set(PETSC_PROCESS_LIBS)
libfind_process(PETSC)

