# -- Find SPARSKIT --
# Cenaero - 10/06/2010
#
# Find the native SPARSKIT headers and libraries.
#
# Input parameters which could influence the search:
# - SPARSKIT_ROOT - root folder where SPARSKIT is installed
#
# Once done, this will define:
# - SPARSKIT_INCLUDE_DIRS - where to find SPARSKIT headers - empty
# - SPARSKIT_LIBRARIES - List of libraries when using SPARSKIT.
# - SPARSKIT_FOUND - True if SPARSKIT found.
#

if(SPARSKIT_LIBRARY)
  set(SPARSKIT_FIND_QUIETLY TRUE)
endif(SPARSKIT_LIBRARY)

include(LibFindMacros)

# Check input parameters
if(SPARSKIT_ROOT)
  set( _SPARSKIT_INCLUDE_SEARCH_DIRS
       ${SPARSKIT_ROOT}/include ${SPARSKIT_ROOT} ${_SPARSKIT_INCLUDE_SEARCH_DIRS})
  set( _SPARSKIT_LIBRARY_SEARCH_DIRS
       ${SPARSKIT_ROOT}/lib ${SPARSKIT_ROOT} ${_SPARSKIT_LIBRARY_SEARCH_DIRS})
endif(SPARSKIT_ROOT)

# Dependencies
# ! none !

# Use pkg-config to get hints about paths
# libfind_pkg_check_modules(SPARSKIT_PKGCONF SPARSKIT)

# Look for the library
find_path(SPARSKIT_INCLUDE_DIR NAMES CSR_Matrix.h 
          PATHS ${_SPARSKIT_INCLUDE_SEARCH_DIRS})
# find_library(SPARSKIT_LIBRARY NAMES Parser 
#              PATHS ${_SPARSKIT_LIBRARY_SEARCH_DIRS} ${SPARSKIT_PKGCONF_LIBRARY_DIRS})

# Set the include dir variables and the libraries and let libfind_process do the rest
set(SPARSKIT_PROCESS_INCLUDES SPARSKIT_INCLUDE_DIR)
set(SPARSKIT_PROCESS_LIBS)
libfind_process(SPARSKIT)

