# Configuration file for BG/Q JuQueen

set(CMAKE_C_COMPILER bgxlc_r)
set(CMAKE_CXX_COMPILER bgxlc++_r)
set(CMAKE_SYSTEM_NAME BlueGeneQ-dynamic)

# Compilation options and flags

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -qpic -qnostaticlink")
set(CMAKE_EXE_LINKER_FLAGS_INIT "-qnostaticlink")
set(CMAKE_SHARED_LINKER_FLAGS "-qmkshrobj")

# Debug
set(CMAKE_CXX_FLAGS_DEBUG "-g -qfullpath -qkeepparm -qsmp=omp:noopt -qthreaded -qcheck -qflttrap -qstrict" CACHE STRING "Debug flags" FORCE)
set(CMAKE_C_FLAGS_DEBUG   "-g -qfullpath -qkeepparm -qsmp=omp:noopt -qthreaded -qcheck -qflttrap -qstrict" CACHE STRING "Debug flags" FORCE)

# RelWithDebInfo
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g -qfullpath -qkeepparm -qsmp=omp -qthreaded -qstrict" CACHE STRING "Relwithdebinfo flags"  FORCE)
set(CMAKE_C_FLAGS_RELWITHDEBINFO   "-O2 -g -qfullpath -qkeepparm -qsmp=omp -qthreaded -qstrict" CACHE STRING "Relwithdebinfo flags" FORCE)

# Release
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -qnohot -qsmp=omp -qthreaded -qstrict -qmaxmem=512000 -DNDEBUG" CACHE STRING "Release flags" FORCE)
set(CMAKE_C_FLAGS_RELEASE   "-O3 -qnohot -qsmp=omp -qthreaded -qstrict -qmaxmem=512000 -DNDEBUG" CACHE STRING "Release flags" FORCE)

# BLAS/LAPACK
list(APPEND ESSL_PATH "/opt/ibmmath/essl/5.1/lib64") # for esslbg
list(APPEND ESSL_PATH "/opt/ibmcmp/xlf/bg/14.1/bglib64") # for xlopt xlf90_r xlfmath xl

# MAdLiB options
set(MADLIB_USE_PARALLEL_DEFAULT ON)

