# Configation file for BGQ Mira and Cetus (ALCF)

set(CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ToolChains/mira-clang11-essl.cmake")


# Compilation options and flags
add_definitions(-DMPICH_IGNORE_CXX_SEEK)
set(DEFAULT_PARALLEL_MPI ON)
set(DEFAULT_PARALLEL_OPENMPI ON)
set(DEFAULT_BUILD_STATIC_LIB ON)

# BLAS/LAPACK
list(APPEND ESSL_PATH "/soft/libraries/essl/current/lib64") # for esslbg
list(APPEND ESSL_PATH "$ENV{IBM_FCMP_DIR}/lib64") # for xlopt xlf90_r xlfmath xl

link_directories(/soft/libraries/essl/current/lib64)
list(APPEND EXTERNAL_LIB esslbg)

link_directories($ENV{IBM_FCMP_DIR}/lib64)
list(APPEND EXTERNAL_LIB xlopt)
list(APPEND EXTERNAL_LIB xlf90_r) # Note: use xlf90 if the unlikely event PARALLEL_OPENMPI is OFF
list(APPEND EXTERNAL_LIB xlfmath)
list(APPEND EXTERNAL_LIB xl)

set(HDF5_DIR_DEFAULT "/soft/libraries/hdf5/current/cnk-xl/current/lib")

set(CMAKE_CXX_FLAGS "-fopenmp -std=c++11 -stdlib=libc++ -Wno-undefined-var-template" CACHE STRING "Standard compilation options" FORCE)

# MAdLiB options
set(MADLIB_USE_PARALLEL_DEFAULT ON)
set(MADLIB_BUILD_STATIC_LIBRARY_DEFAULT ON)
set(MADLIB_BUILD_SHARED_LIBRARY_DEFAULT OFF)
    
	

