# Configation file for BGQ Mira and Cetus (ALCF)

set(CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ToolChains/mira-xl.cmake")

# Debug
set(CMAKE_CXX_FLAGS_DEBUG "-g -qfullpath -qkeepparm -qsmp=omp:noopt -qthreaded -qcheck -qflttrap -qstrict " CACHE STRING "Debug compiler flags" FORCE)
set(CMAKE_C_FLAGS_DEBUG   "-g -qfullpath -qkeepparm -qsmp=omp:noopt -qthreaded -qcheck -qflttrap -qstrict" CACHE STRING "Debug compiler flags" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-L/soft/debuggers/ddt/lib/64 -ldmallocthcxx -Wl,--allow-multiple-definition" CACHE STRING "Debug linker flags" FORCE)

# RelWithDebInfo
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g -qfullpath -qkeepparm -qsmp=omp -qthreaded -qstrict" CACHE STRING "Relwithdebinfo flags"  FORCE)
set(CMAKE_C_FLAGS_RELWITHDEBINFO   "-O2 -g -qfullpath -qkeepparm -qsmp=omp -qthreaded -qstrict" CACHE STRING "Relwithdebinfo flags" FORCE)

# Release
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -qnohot -qsmp=omp -qthreaded -qstrict -qmaxmem=512000 -DNDEBUG" CACHE STRING "Release flags" FORCE)
set(CMAKE_C_FLAGS_RELEASE   "-O3 -qnohot -qsmp=omp -qthreaded -qstrict -qmaxmem=512000 -DNDEBUG" CACHE STRING "Release flags" FORCE)

# BLAS/LAPACK
list(APPEND ESSL_PATH "/soft/libraries/essl/current/lib64") # for esslbg
list(APPEND ESSL_PATH "$ENV{IBM_FCMP_DIR}/lib64") # for xlopt xlf90_r xlfmath xl

link_directories(/soft/libraries/essl/current/lib64)
list(APPEND EXTERNAL_LIB esslbg)

link_directories($ENV{IBM_FCMP_DIR}/lib64)
list(APPEND EXTERNAL_LIB xlopt)
list(APPEND EXTERNAL_LIB xlf90_r) # Note: use xlf90 if the unlikely event PARALLEL_OPENMPI is OFF
list(APPEND EXTERNAL_LIB xlfmath)
list(APPEND EXTERNAL_LIB xl)

set(HDF5_DIR_DEFAULT "/soft/libraries/hdf5/current/cnk-xl/current/lib")

# MAdLiB options
set(MADLIB_USE_PARALLEL_DEFAULT ON)
set(MADLIB_BUILD_STATIC_LIBRARY_DEFAULT ON)
set(MADLIB_BUILD_SHARED_LIBRARY_DEFAULT OFF)
    
	

